thf(t_nat,type,(nat : $tType)).
thf(t_one_n,type,(one_n : nat)).
thf(t_succ_n,type,(succ_n : (nat > nat))).
thf(a_succ_one,axiom,(! [M:nat] : ((succ_n @ M) != one_n))).
thf(a_succ_inj,axiom,(! [M:nat] : (! [N:nat] : (((succ_n @ M) = (succ_n @ N)) => (M = N))))).
thf(a_ind,axiom,(! [P:(nat > $o)] : ((P @ one_n) => ((! [M:nat] : ((P @ M) => (P @ (succ_n @ M)))) => (! [M:nat] : (P @ M)))))).

thf(t_plus_n,type,(plus_n : (nat > (nat > nat)))).
thf(t_mult_n,type,(mult_n : (nat > (nat > nat)))).
thf(a_plus_n_o,axiom,(! [M:nat] : ((plus_n @ M @ one_n) = (succ_n @ M)))).
thf(a_plus_n_s,axiom,(! [M:nat] : (! [N:nat] : ((plus_n @ M @ (succ_n @ N)) = (succ_n @ (plus_n @ M @ N)))))).
thf(a_mult_n_o,axiom,(! [M:nat] : ((mult_n @ M @ one_n) = M))).
thf(a_mult_n_s,axiom,(! [M:nat] : (! [N:nat] : ((mult_n @ M @ (succ_n @ N)) = (plus_n @ (mult_n @ M @ N) @ M))))).

thf(t_int,type,(int : $tType)).
thf(t_zero,type,(zero : int)).
thf(t_pos,type,(pos : (nat > int))).
thf(t_neg,type,(neg : (nat > int))).
thf(a_pos_zero,axiom,(! [M:nat] : ((pos @ M) != zero))).
thf(a_neg_zero,axiom,(! [M:nat] : ((neg @ M) != zero))).
thf(a_pos_neg,axiom,(! [M:nat] : ((pos @ M) != (neg @ M)))).
thf(a_pos_inj,axiom,(! [M:nat] : (! [N:nat] : (((pos @ M) = (pos @ N)) => (M = N))))).
thf(a_neg_inj,axiom,(! [M:nat] : (! [N:nat] : (((neg @ M) = (neg @ N)) => (M = N))))).
thf(a_int_cases,axiom,(! [M:int] : ((M = zero) | (? [N:nat] : (M = (pos @ N))) | (? [N:nat] : (M = (neg @ N)))))).
thf(t_plus,type,(plus : (int > (int > int)))).
thf(t_lt,type,(lt : (int > (int > $o)))).
thf(t_leq,type,(leq : (int > (int > $o)))).
thf(t_mult,type,(mult : (int > (int > int)))).
thf(t_diff,type,(diff : (int > (int > int)))).
thf(t_div,type,(div : (int > (int > int)))).
thf(t_mod,type,(mod : (int > (int > int)))).
thf(a_plus_com,axiom,(! [M:int] : (! [N:int] : ((plus @ M @ N) = (plus @ N @ M))))).
thf(a_plus_assoc,axiom,(! [M:int] : (! [N:int] : (! [K:int] : ((plus @ M @ (plus @ N @ K)) = (plus @ (plus @ M @ N) @ K)))))).
thf(a_plus_z,axiom,(! [M:int] : ((plus @ M @ zero) = M))).
thf(a_plus_pos_pos,axiom,(! [M:nat] : (! [N:nat] : ((plus @ (pos @ M) @ (pos @ N)) = (pos @ (plus_n @ M @ N)))))).
thf(a_plus_neg_neg,axiom,(! [M:nat] : (! [N:nat] : ((plus @ (neg @ M) @ (neg @ N)) = (neg @ (plus_n @ M @ N)))))).
thf(a_plus_pos_neg,axiom,(! [M:nat] : (! [N:nat] : (((M = N) & ((plus @ (pos @ M) @ (neg @ N)) = zero)) | (? [K:nat] : (((plus_n @ M @ K) = N) & ((plus @ (pos @ M) @ (neg @ N)) = (neg @ K)))) | (? [K:nat] : (((plus_n @ N @ K) = M) & ((plus @ (pos @ M) @ (neg @ N)) = (pos @ K)))))))).
thf(a_lt_def,axiom,(! [M:int] : (! [N:int] : ((lt @ M @ N) <=> (? [K:nat] : ((plus @ M @ (pos @ K)) = N)))))).
thf(a_leq_def,axiom,(! [M:int] : (! [N:int] : ((leq @ M @ N) <=> (lt @ M @ (plus @ N @ (pos @ one_n))))))).
thf(a_mult_com,axiom,(! [M:int] : (! [N:int] : ((mult @ M @ N) = (mult @ N @ M))))).
thf(a_mult_assoc,axiom,(! [M:int] : (! [N:int] : (! [K:int] : ((mult @ M @ (mult @ N @ K)) = (mult @ (mult @ M @ N) @ K)))))).
thf(a_dist,axiom,(! [M:int] : (! [N:int] : (! [K:int] : ((mult @ M @ (plus @ N @ K)) = (plus @ (mult @ M @ N) @ (mult @ M @ K))))))).
thf(a_mult_z,axiom,(! [M:int] : ((mult @ M @ zero) = zero))).
thf(a_mult_one,axiom,(! [M:int] : ((mult @ M @ (pos @ one_n)) = M))).
thf(a_mult_pos_pos,axiom,(! [M:nat] : (! [N:nat] : ((mult @ (pos @ M) @ (pos @ N)) = (pos @ (mult_n @ M @ N)))))).
thf(a_mult_neg_neg,axiom,(! [M:nat] : (! [N:nat] : ((mult @ (neg @ M) @ (neg @ N)) = (pos @ (mult_n @ M @ N)))))).
thf(a_mult_pos_neg,axiom,(! [M:nat] : (! [N:nat] : ((mult @ (pos @ M) @ (neg @ N)) = (neg @ (mult_n @ M @ N)))))).
thf(a_diff_def,axiom,(! [M:int] : (! [N:int] : (! [K:int] : (((diff @ M @ N) = K) <=> ((plus @ N @ K) = M)))))).
thf(a_div_mod_prop,axiom,(! [M:int] : (! [N:int] : ((lt @ zero @ N) => (! [Q:int] : (! [R:int] : ((((div @ M @ N) = Q) & ((mod @ M @ N) = R)) <=> ((leq @ zero @ R) & (lt @ R @ N) & ((plus @ (mult @ N @ Q) @ R) = M))))))))).
thf(t_prog,type,(prog2 : $tType)).
thf(t_ZERO,type,(p_ZERO : prog2)).
thf(t_ONE,type,(p_ONE : prog2)).
thf(t_TWO,type,(p_TWO : prog2)).
thf(t_ADDI,type,(p_ADDI : (prog2 > (prog2 > prog2)))).
thf(t_DIFF,type,(p_DIFF : (prog2 > (prog2 > prog2)))).
thf(t_MULT,type,(p_MULT : (prog2 > (prog2 > prog2)))).
thf(t_DIVI,type,(p_DIVI : (prog2 > (prog2 > prog2)))).
thf(t_MODU,type,(p_MODU : (prog2 > (prog2 > prog2)))).
thf(t_COND,type,(p_COND : (prog2 > (prog2 > (prog2 > prog2))))).
thf(t_LOOP,type,(p_LOOP : (prog2 > (prog2 > (prog2 > prog2))))).
thf(t_LOOP2,type,(p_LOOP2 : (prog2 > (prog2 > (prog2 > (prog2 > (prog2 > prog2))))))).
thf(t_X,type,(p_X : prog2)).
thf(t_Y,type,(p_Y : prog2)).
thf(t_ev2,type,(ev2 : (prog2 > (int > (int > int))))).
thf(t_ev2loop2,type,(ev2loop2 : (prog2 > (prog2 > (int > (int > (int > int))))))).
thf(a_ev2_ZERO,axiom,(! [M:int] : (! [N:int] : ((ev2 @ p_ZERO @ M @ N) = zero)))).
thf(a_ev2_ONE,axiom,(! [M:int] : (! [N:int] : ((ev2 @ p_ONE @ M @ N) = (pos @ one_n))))).
thf(a_ev2_TWO,axiom,(! [M:int] : (! [N:int] : ((ev2 @ p_TWO @ M @ N) = (pos @ (succ_n @ one_n)))))).
thf(a_ev2_X,axiom,(! [M:int] : (! [N:int] : ((ev2 @ p_X @ M @ N) = M)))).
thf(a_ev2_Y,axiom,(! [M:int] : (! [N:int] : ((ev2 @ p_Y @ M @ N) = N)))).
thf(a_ev2_ADDI,axiom,(! [P:prog2] : (! [Q:prog2] : (! [M:int] : (! [N:int] : ((ev2 @ (p_ADDI @ P @ Q) @ M @ N) = (plus @ (ev2 @ P @ M @ N) @ (ev2 @ Q @ M @ N)))))))).
thf(a_ev2_DIFF,axiom,(! [P:prog2] : (! [Q:prog2] : (! [M:int] : (! [N:int] : ((ev2 @ (p_DIFF @ P @ Q) @ M @ N) = (diff @ (ev2 @ P @ M @ N) @ (ev2 @ Q @ M @ N)))))))).
thf(a_ev2_MULT,axiom,(! [P:prog2] : (! [Q:prog2] : (! [M:int] : (! [N:int] : ((ev2 @ (p_MULT @ P @ Q) @ M @ N) = (mult @ (ev2 @ P @ M @ N) @ (ev2 @ Q @ M @ N)))))))).
thf(a_ev2_DIVI,axiom,(! [P:prog2] : (! [Q:prog2] : (! [M:int] : (! [N:int] : ((ev2 @ (p_DIVI @ P @ Q) @ M @ N) = (div @ (ev2 @ P @ M @ N) @ (ev2 @ Q @ M @ N)))))))).
thf(a_ev2_MODU,axiom,(! [P:prog2] : (! [Q:prog2] : (! [M:int] : (! [N:int] : ((ev2 @ (p_MODU @ P @ Q) @ M @ N) = (mod @ (ev2 @ P @ M @ N) @ (ev2 @ Q @ M @ N)))))))).
thf(a_ev2_COND_0,axiom,(! [P:prog2] : (! [Q:prog2] : (! [R:prog2] : (! [M:int] : (! [N:int] : ((leq @ (ev2 @ P @ M @ N) @ zero) => ((ev2 @ (p_COND @ P @ Q @ R) @ M @ N) = (ev2 @ Q @ M @ N))))))))).
thf(a_ev2_COND_1,axiom,(! [P:prog2] : (! [Q:prog2] : (! [R:prog2] : (! [M:int] : (! [N:int] : ((lt @ zero @ (ev2 @ P @ M @ N)) => ((ev2 @ (p_COND @ P @ Q @ R) @ M @ N) = (ev2 @ R @ M @ N))))))))).
thf(a_ev2_LOOP_0,axiom,(! [P:prog2] : (! [Q:prog2] : (! [R:prog2] : (! [M:int] : (! [N:int] : ((leq @ (ev2 @ Q @ M @ N) @ zero) => ((ev2 @ (p_LOOP @ P @ Q @ R) @ M @ N) = (ev2 @ R @ M @ N))))))))).
thf(a_ev2_LOOP_1,axiom,(! [P:prog2] : (! [Q:prog2] : (! [R:prog2] : (! [M:int] : (! [N:int] : ((lt @ zero @ (ev2 @ Q @ M @ N)) => ((ev2 @ (p_LOOP @ P @ Q @ R) @ M @ N) = (ev2 @ P @ (ev2 @ (p_LOOP @ P @ (p_DIFF @ Q @ p_ONE) @ R) @ M @ N) @ M))))))))).
thf(a_ev2_LOOP2,axiom,(! [F:prog2] : (! [G:prog2] : (! [A:prog2] : (! [B:prog2] : (! [C:prog2] : (! [M:int] : (! [N:int] : ((ev2 @ (p_LOOP2 @ F @ G @ A @ B @ C) @ M @ N) = (ev2loop2 @ F @ G @ (ev2 @ A @ M @ N) @ (ev2 @ B @ M @ N) @ (ev2 @ C @ M @ N))))))))))).
thf(a_ev2loop2_0,axiom,(! [F:prog2] : (! [G:prog2] : (! [A:int] : (! [B:int] : (! [C:int] : ((leq @ A @ zero) => ((ev2loop2 @ F @ G @ A @ B @ C) = B)))))))).
thf(a_ev2loop2_1,axiom,(! [F:prog2] : (! [G:prog2] : (! [A:int] : (! [B:int] : (! [C:int] : ((lt @ zero @ A) => ((ev2loop2 @ F @ G @ A @ B @ C) = (ev2loop2 @ F @ G @ (diff @ A @ (pos @ one_n)) @ (ev2 @ F @ B @ C) @ (ev2 @ G @ B @ C)))))))))).
thf(conj,conjecture,((ev2 @ (p_DIVI @ (p_LOOP @ (p_MULT @ (p_MULT @ p_X @ p_X) @ p_X) @ p_TWO @ (p_ADDI @ p_TWO @ (p_MULT @ p_TWO @ (p_ADDI @ p_TWO @ p_TWO)))) @ (p_ADDI @ p_ONE @ p_X)) @ (pos @ one_n) @ zero) = (ev2 @ (p_DIVI @ (p_LOOP @ (p_LOOP2 @ (p_ADDI @ (p_MULT @ p_X @ p_Y) @ p_X) @ p_Y @ p_X @ p_ONE @ p_X) @ p_TWO @ p_TWO) @ (p_ADDI @ p_ONE @ p_X)) @ (pos @ one_n) @ zero))).
